import 'package:flutter/material.dart';

///[NavigationDestination] class is encapsulated [BackdropPage] and addition args
class NavigationDestination{
  NavigationDestination({@required this.icon, @required this.title, this.subTitle, this.actions = const <Widget>[], @required this.child}) : assert(icon != null && title != null && child != null);
  final Icon icon;
  final Widget title;
  final Widget subTitle;
  final List<Widget> actions;
  final WidgetBuilder child;
}

class BackdropPage extends StatelessWidget{
  BackdropPage({Key key, this.subTitle, @required this.child, @required this.fling}) : assert(child != null && fling != null), super(key: key);
  final Widget subTitle;
  final WidgetBuilder child;
  final void Function() fling;
  @override
  Widget build(BuildContext context) {
    return  LayoutBuilder(
      builder: (context, constraints){
        return Container(
          decoration: BoxDecoration(
            color: Theme.of(context).scaffoldBackgroundColor,
            borderRadius: const BorderRadius.only(
              topLeft: Radius.circular(16),
              topRight: Radius.circular(16)
            )
          ),
          child: Column(
            children: <Widget>[
              if(subTitle != null) Container(
                padding: const EdgeInsets.symmetric(vertical: 8, horizontal: 16),
                height: 46,
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  mainAxisSize: MainAxisSize.max,
                  children: <Widget>[
                    subTitle,
                  ],
                ),
              ),
              GestureDetector(
                behavior: HitTestBehavior.translucent,
                onTap: fling,
                child: SizedBox(
                height: subTitle != null ? constraints.maxHeight - 46 : constraints.maxHeight,
                  width: constraints.maxWidth,
                  child: child(context),
                ),
              )
            ],
          ),
        );
      },
    );
  }
}